include	version.inc
include	clib.inc
include dir.inc
include fblk.inc
include wsub.inc
include filter.inc

ifdef __NOX__
 USE_CALENDAR	= 0	; Inline Calendar
 USE_PACKER	= 0	; Inline Packer
 USE_FILEFIND	= 0	; Inline File Find
 USE_COLOREDIT	= 0	; Edit Color
 USE_TEXTVIEW	= 0	; Inline Text View
 USE_READZIP	= 0	; Read ZIP Files
 USE_WRITEZIP	= 0	; Write ZIP Files - v1.55
 USE_UNZIP	= 0	; Inline unzip
else
 USE_CALENDAR	= 1
 USE_PACKER	= 1
 USE_FILEFIND	= 1
 USE_COLOREDIT	= 1
 USE_TEXTVIEW	= 1
 USE_READZIP	= 1
 USE_WRITEZIP	= 1
 USE_UNZIP	= 1
endif

; Configuration file:	DZ.CFG

_C_PANELID	= 0001h	; config.c_lflag
_C_HORIZONTAL	= 0002h
_C_ESCUSERSCR	= 0004h
_C_EGALINE	= 0008h
_C_SELECTDIR	= 0010h
_C_INSMOVDN	= 0020h
_C_CDCLRDONLY	= 0040h
_C_AUTOSAVE	= 0080h
_C_SORTDIR	= 0100h
_C_SWAPFF	= 0200h
_C_SAVEHISTORY	= 0400h
_C_DELTEMP	= 0800h
_C_MENUSLINE	= 1000h
_C_STATUSLINE	= 2000h
_C_COMMANDLINE	= 4000h
_C_CFGRDONLY	= 8000h
_C_DEFAULT      = 70F0h

_C_CONFCOPY	= 01h	; config.c_confirm
_C_CONFMOVE	= 02h
_C_CONFDELETE	= 04h
_C_CONFDELSUB	= 08h
_C_CONFSYSTEM	= 10h
_C_CONFRDONLY	= 20h
_C_CONFEXIT	= 40h

_C_ZPACKERID	= 000Fh	; config.c_compress
_C_ZINCDIR	= 0010h
_C_ZDECOMP	= 0020h
_C_ZSMALLEST	= 0100h
_C_ZFASTEST	= 0200h
_C_ZBEST	= 0300h
_C_ZPASSWORD	= 0400h
_C_ZINCSUBDIR	= 1000h
_C_ZCREATEZIP	= 2000h

_TV_TEXTVIEW	= 00h	; config.c_tvflag
_TV_CLASSVIEW	= 01h
_TV_HEXVIEW	= 02h
_TV_BINVIEW	= 04h
_TV_WRAPLINES	= 08h
_TV_HEXOFFSET	= 10h
_TV_HIGHCOLOR	= 20h
_TV_CLIPBOARD	= 40h

S_CONFIG	STRUC
c_version	DW ?	; hex: 0.1.3.8 --> 0138h
c_lflag		DW ?
c_confirm	DB ?
c_console	DB ?	; -- console.inc
c_exconsole	DB ?	; -- extended
c_fsflag	DB ?	; -- iost.inc
c_tvflag	DB ?	; -- tview.asm
c_teflag	DW ?	; -- tedit.asm
c_tepages	DW ?	; -- tedit.asm Max EMS pages to alloc
c_telsize	DW ?	; -- tedit.asm Max line length
c_compress	DW ?	; -- packer.asm
c_comprlevel	DB ?
c_panelsize	DB ?	; Alt-Up/Down
c_fcb_indexa	DW ?
c_cel_indexa	DW ?
c_fcb_indexb	DW ?
c_cel_indexb	DW ?
c_apath		DB SIZE S_PATH dup(?)
c_bpath		DB SIZE S_PATH dup(?)
c_filter	DB SIZE S_FILT dup(?)
c_color		DB 40 dup(?)
c_pending_file	DB 260 dup(?)
S_CONFIG 	ENDS

S_MEMCONFIG 	STRUC
mc_memconfig	DW ?	; set by configwrite
mc_lflag	DW ?
mc_confirm	DB ?
mc_console	DB ?
mc_exconsole	DB ?
mc_fsflag	DB ?
mc_tvflag	DB ?
mc_teflag	DW ?
mc_compress	DW ?
mc_comprlevel	DB ?
mc_panelsize	DB ?
mc_fcb_indexa	DW ?
mc_cel_indexa	DW ?
mc_fcb_indexb	DW ?
mc_cel_indexb	DW ?
mc_flaga	DW ?
mc_flagb	DW ?
mc_path		DB SIZE S_PATH dup(?)
S_MEMCONFIG	ENDS	; 841 byte

S_XCELL		STRUC
xl_flag		DW ?	; DOBJ.dl_flag
xl_cols		DB ?	; number of files in one line
xl_rows		DB ?	; number of lines in panel
xl_rect		DD ?	; the current position of cell
xl_bp		DD ?	; DOBJ.dl_wp
xl_cpos		DD ?	; position of first cell in panel
S_XCELL		ENDS

S_PANEL		STRUC
pn_flag		DW ?	; -- wsub.inc
pn_fcb_count	DW ?
pn_fcb_index	DW ?
pn_cel_count	DW ?
pn_cel_index	DW ?
pn_xl		DW ?
pn_dialog	DW ?
pn_wsub		DW ?
pn_putfcb	DW ?
S_PANEL		ENDS

S_MKLST		STRUC
mkl_macro	db ?	; use output macro
mkl_append	db ?	; add to list or create new
mkl_unix	db ?	; convert to unix
mkl_excl_cd	db ?	; use local directory
mkl_excl_drv	db ?	; use drive in directory
mkl_offspath	dw ?	; length of local directory
mkl_offset_ax	dw ?	; search offset from findfile
mkl_offset_dx	dw ?	; or 0
mkl_handle	dw ?
mkl_count_ax	dw ?	; total file count in list
mkl_count_dx	dw ?	;
S_MKLST		ENDS

GLOBAL	config:		WORD
GLOBAL	cflag:		WORD
GLOBAL	fsflag:		BYTE
GLOBAL	tvflag:		BYTE
GLOBAL	teflag:		WORD
GLOBAL	tepages:	WORD
GLOBAL	telsize:	WORD
GLOBAL	path_a:		WORD
GLOBAL	path_b:		WORD
GLOBAL	compressflag:	WORD
GLOBAL	compresslevel:	BYTE

GLOBAL	envconf:	DWORD	; %DZ%
GLOBAL	programpath:	BYTE	; _argv[0]/C<directory>
GLOBAL	configfile:	BYTE	; envconf/programpath
GLOBAL	searchstring:	BYTE
GLOBAL	dzexe:		DWORD	; DZ.EXE
GLOBAL	envconf:	DWORD	; %DZ%
GLOBAL	envpath:	DWORD	; %PATH%
GLOBAL	envtemp:	DWORD	; %TEMP%
GLOBAL	comspec:	DWORD	; %COMSPEC%

GLOBAL	cpanel:		WORD
GLOBAL	panela:		WORD
GLOBAL	panelb:		WORD
GLOBAL	spanela:	WORD
GLOBAL	spanelb:	WORD
GLOBAL	wspanela:	WORD
GLOBAL	wspanelb:	WORD
GLOBAL	prect_a:	WORD
GLOBAL	prect_b:	WORD
GLOBAL	wsmaxfba:	WORD
GLOBAL	wsmaxfbb:	WORD
GLOBAL	mklist:		S_MKLST

GLOBALN	getinifile
GLOBALN	getcfgfile
GLOBALN	getcmdfile
GLOBALN config_read
GLOBALN config_save
GLOBALN history_open
GLOBALN history_save
GLOBALN history_delete
GLOBALN history_close
GLOBALN doskey_save

GLOBALN	prect_show	; DS:AX
GLOBALN	prect_hide
GLOBALN	prect_close
GLOBALN	prect_open
GLOBALN	prect_clear	; rect:DWORD, ptype:WORD

GLOBALN fblk_select	; fblk:DWORD
GLOBALN fblk_invert	; fblk:DWORD
GLOBALN pcell_select	; AX = panel
GLOBALN pcell_set	; AX = panel
GLOBALN pcell_open	; AX = panel
GLOBALN pcell_show	; AX = panel
GLOBALN pcell_update	; AX = panel
GLOBALN pcell_move	; panel:WORD, xpos:WORD, ypos:WORD
GLOBALN pcell_setxy	; panel:WORD, xpos:WORD, ypos:WORD

GLOBALN	cpanel_state
GLOBALN	cpanel_findfirst
GLOBALN	cpanel_gettarget
GLOBALN	cpanel_setpath
GLOBALN	cpanel_deselect	; fblk:DWORD

GLOBALN	panel_state	; AX = panel
GLOBALN	panel_open	; AX = panel
GLOBALN	panel_close	; AX = panel
GLOBALN panel_hide	; AX = panel
GLOBALN panel_show	; AX = panel
GLOBALN panel_setactive	; AX = panel
GLOBALN panel_curobj	; AX = panel
GLOBALN panel_findnext	; AX = panel
GLOBALN panel_openmsg	; AX = panel
GLOBALN panel_putinfo	; AX = panel
GLOBALN panel_putmini	; AX = panel
GLOBALN panel_read	; AX = panel
GLOBALN panel_reread	; AX = panel
GLOBALN panel_redraw	; AX = panel
GLOBALN panel_toggle	; AX = panel
GLOBALN panel_update	; AX = panel
GLOBALN panel_xormini	; AX = panel
GLOBALN panel_xorinfo	; AX = panel
GLOBALN panel_setid	; panel:AX, index:DX
GLOBALN panel_putitem	; panel:WORD, index:WORD
GLOBALN panel_xycmd	; panel:WORD, xpos:WORD, ypos:WORD
GLOBALN panel_sethdd	; panel:WORD, hdd:WORD
GLOBALN panel_event	; panel:WORD, event:WORD

GLOBALN	panel_stateab
GLOBALN redraw_panels	; AX = panel

GLOBALD	cmalong
GLOBALD	cmadetail
GLOBALD	cmahidden
GLOBALD	cmamini
GLOBALD	cmavolinfo
GLOBALD	cmaname
GLOBALD	cmatype
GLOBALD	cmadate
GLOBALD	cmasize
GLOBALD	cmanosort
GLOBALD	cmatoggle
GLOBALD	cmafilter
GLOBALD	cmasubinfo
GLOBALD	cmaupdate
GLOBALD	cmachdrv

GLOBALD	cmrename
GLOBALD	cmview
GLOBALD	cmedit
GLOBALD	cmcopy
GLOBALD	cmmove
GLOBALD	cmmkdir
GLOBALD	cmdelete
GLOBALD	cmattrib
GLOBALD	cmcompress
GLOBALD	cmdecompress
if USE_FILEFIND
GLOBALD	cmsearch
endif
GLOBALD	cmhistory
GLOBALD	cmexit

GLOBALD	cmselect
GLOBALD	cmdeselect
GLOBALD	cminvert
GLOBALD	cmquicksearch	; Ctrl-Q
GLOBALD	cmcompare

GLOBALD	cmtoggleon
GLOBALD	cmtogglehz
GLOBALD	cmtogglesz
GLOBALD	cmegaline
GLOBALD	cmswap
GLOBALD	cmconfirm
GLOBALD	cmscreen
GLOBALD	cmpanel
GLOBALD	cmcompression
GLOBALD	cmsystem
GLOBALD	cmoptions

GLOBALD	cmhelp
GLOBALD	cmabout

GLOBALD	cmblong
GLOBALD	cmbdetail
GLOBALD	cmbhidden
GLOBALD	cmbmini
GLOBALD	cmbvolinfo
GLOBALD	cmbname
GLOBALD	cmbtype
GLOBALD	cmbdate
GLOBALD	cmbsize
GLOBALD	cmbnosort
GLOBALD	cmbtoggle
GLOBALD	cmbfilter
GLOBALD	cmbsubinfo
GLOBALD	cmbupdate
GLOBALD	cmbchdrv

GLOBALD	cmawideview
GLOBALD	cmbwideview
GLOBALD	cmcwideview

GLOBALD	cmcopycell
GLOBALD	cmlastmenu
GLOBALD	cmtool0
GLOBALD	cmtool1
GLOBALD	cmtool2
GLOBALD	cmtool3
GLOBALD	cmtool4
GLOBALD	cmtool5
GLOBALD	cmtool6
GLOBALD	cmtool7
GLOBALD	cmtool8
GLOBALD	cmtool9
GLOBALD	cmpath0
GLOBALD	cmpath1
GLOBALD	cmpath2
GLOBALD	cmpath3
GLOBALD	cmpath4
GLOBALD	cmpath5
GLOBALD	cmpath6
GLOBALD	cmpath7
GLOBALD	cmpath8
GLOBALD	cmpath9
GLOBALD	cmcname
GLOBALD	cmctype
GLOBALD	cmcdate
GLOBALD	cmcsize
GLOBALD	cmuserscreen
GLOBALD	cmchidden
GLOBALD	cmclong
GLOBALD	cmcmini
GLOBALD	cmcupdate
GLOBALD	cmcdetail
GLOBALD	cmcnosort
GLOBALD	cmvolinfo
GLOBALD	cmxormenubar
GLOBALD	cmxorkeybar
GLOBALD	cmxorcmdline
GLOBALD	cmupdir
GLOBALD	cmsubdir
GLOBALD	cmctrlenter
GLOBALD	cmclrcmdl
GLOBALD	cmpsizeup
GLOBALD	cmpsizedn
GLOBALD	cmpathleft      ; Alt-Left  - Previous Directory
GLOBALD	cmpathright	; Alt-Right - Next Directory
GLOBALD	cmdoskey_up	; Alt-Up    - Previous Command
GLOBALD	cmdoskey_dn	; Alt-Down  - Next Command
GLOBALD	cmsavesetup	; Shift-F10
GLOBALD	cmsubsize	; F3
GLOBALD	cmsubinfo	; Menus
GLOBALD	cmquit		; Alt-X
GLOBALD	clrcmdl		; Esc
GLOBALD	cmfilter
GLOBALD	cmmklist	; Alt-L
GLOBALD	cmloadpath	; Alt-P
if USE_CALENDAR
 GLOBALD cmcalendar	; Ctrl-G
endif
if USE_WRITEZIP
 GLOBALD cmmkzip	; Shift-F7
endif
ifdef DEBUG
 GLOBALD cmdebug	; Shift-F1
endif
GLOBALD	cmmemory	; Alt-M

GLOBALN	setconfirmflag

GLOBAL	dzcount:	WORD
GLOBAL	mainswitch:	WORD
GLOBAL	dzexitcode:	WORD
GLOBAL	global_key:	WORD
GLOBAL	argvfile:	WORD

GLOBAL	com_base: 	BYTE
GLOBAL	com_wsub:	WORD

GLOBALN cominit
GLOBALN comshow
GLOBALN comhide
GLOBALN comevent

GLOBAL	convbuf: 	BYTE
GLOBAL	configextp: 	WORD
GLOBAL	cp_dzcmd:	BYTE

GLOBALN command		; cmdl:DWORD
GLOBALN expand_environ	; cmdl:DWORD
GLOBALN fbinitype	; fb:DWORD, cmdl:DWORD

GLOBAL	findfilemask:	BYTE

GLOBALN	load_tedit
GLOBALN	load_tview
GLOBALN	loadiniproc
GLOBALN	cm_loadfblk

GLOBAL	cp_copy:	BYTE
GLOBAL	cp_space:	BYTE
GLOBAL	cp_missingTEMP:	BYTE

GLOBAL	numfblock:	WORD

GLOBAL	DLG_Commandline:DWORD
GLOBAL	DLG_Statusline:	DWORD

GLOBAL	cp_tools:	BYTE
GLOBALN	open_idd
GLOBALN	modal_idd
GLOBALN	close_idd
GLOBALN	statusline_xy

GLOBALN	apiupdate

GLOBAL	password:	BYTE
GLOBAL	enterpassword:	BYTE
GLOBAL	cp_needpanel:	BYTE
GLOBAL	cp_recursive:	BYTE
GLOBAL	cp_default:	BYTE

GLOBALD	notsup

GLOBAL	CRLF$:		BYTE
GLOBAL	cp_search:	BYTE

GLOBALD	cmfilter_load
GLOBALD	view_readme

GLOBAL	cp_compare:	BYTE
GLOBAL	cp_copyselected:BYTE
GLOBAL	cp_delete:	BYTE
GLOBAL	cp_ziplst:	BYTE

GLOBALN	ret_update_AB
GLOBALD	mkziplst
GLOBALD	mkziplst_open

GLOBAL	cp_directory:	BYTE
GLOBALN	TOOLS_IDD

GLOBAL	cp_move:	BYTE
GLOBAL	copy_jump:	WORD
GLOBAL	copy_flag:	BYTE

GLOBALD	fp_copydirectory
GLOBALD	fp_copyfile
GLOBALN	copyfile

GLOBAL	cp_select:	BYTE
GLOBAL	cp_deselect:	BYTE

GLOBALN	apiopen
GLOBALN	prect_open_ab
GLOBALN	panel_open_ab
GLOBALN	apiclose

GLOBAL	cp_compress:	BYTE
GLOBAL	cp_decompress:	BYTE

GLOBALP	removetemp,	:DWORD

ifdef 	LPROG
_DZIP	SEGMENT WORD USE16 public 'CODE'
_DZIP	ENDS
	ASSUME CS:_DZIP, DS:DGROUP
else
_DZIP	EQU 	<_TEXT>
endif


